'*******************************************************
' Name  : beaufort.bas
' Author : DG1XPZ
' Purpose :conversion wind rate into wind velocity
' Version :V0.1
' Compiler :Bascom-AVR 1.11.7.4
' Bytes   : 2332
' Chiptype :Atmel-AVR
'*******************************************************

$regfile = "m8def.dat"
$crystal = 4000000

Declare Function Beaufort(wind As Word) As Integer
Dim Wind_v As Word
Dim Windstaerke As Integer

Wind_v = 150                                                'Wert Windgeschwindigkeit
Windstaerke = Beaufort(wind_v)
Print Wind_v ; "Km/h = Windstaerke(Beaufort): " ; Windstaerke       'Ausgabe der Windstaerke

Function Beaufort(wind As Word) As Integer
  Dim Ws As Single
  Dim Tmp As Single
  Dim Wsi As Integer
  Ws = Wind / 3.6
  Ws = Ws - 0.07
  Ws = Ws / 0.834
  Ws = Ws * Ws
  Ws = Log(ws)
  Tmp = Log(10)
  Ws = Ws / Tmp
  Ws = Ws / 3
  Tmp = 10
  Ws = Power(tmp , Ws)
  Ws = Round(ws)
  Wsi = Int(ws)
  Beaufort = Wsi
End Function

End